<?php
namespace Teknisa\FIS\Modules\Acessorias\Controllers;

use Teknisa\FIS\Modules\Acessorias\Services\Fis83000DiefPAService;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response\Error;


class Fis83000DiefPAController {

    protected $diefPAService;

    public function __construct(EntityManager $entityManager, Fis83000DiefPAService $diefPAService
    ) {
        $this->entityManager    = $entityManager;
        $this->diefPAService    = $diefPAService;
        set_time_limit(0);
    }

    /*
     * Função para realizar a exportação do SINTEGRA.
     */
    public function exportarDiefPA(DTO\Request $request, DTO\Response $response) {
        try {
          
            $row = $request->getRow();
            
            $row["NMARQUIVO"] = str_replace(' ', '', $row["NMARQUIVO"]);
            
            // Chama a função de exportação.
            $fileName = $this->diefPAService->exportarDiefPA($row);

            // Retorna o nome do arquivo exportado.
            $response->addDataset(new DataSet('columnsToReturn', array("fileName" => $fileName)));
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
}
