/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ESPECIFICABEM                                            */
/* Tabela : ESPECIFICABEM                                                     */
/*                                                                            */
/* Criao:                                                                   */
/* 26/03/2009 - Luciana Correa de Figueiredo                                  */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE
TRIGGER DTULTATU_ESPECIFICABEM
BEFORE INSERT OR UPDATE OR DELETE
ON ESPECIFICABEM FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF(NVL(:OLD.CDEMPRESA ,     0) <> NVL(:NEW.CDEMPRESA,      0)) OR
        (NVL(:OLD.CDESPECIFICABEM,0) <> NVL(:NEW.CDESPECIFICABEM,0)) OR
        (NVL(:OLD.NMESPECIFICABEM,0) <> NVL(:NEW.NMESPECIFICABEM,0)) OR
        (NVL(:OLD.NMABREVESPECBEM,0) <> NVL(:NEW.NMABREVESPECBEM,0)) OR
        (NVL(:OLD.IDESPECIFICABEM,0) <> NVL(:NEW.IDESPECIFICABEM,0)) THEN
        :NEW.DTULTATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE,CDFILICACHE,DSKEYCACHE,DTULTATUCACH)
      VALUES ('ESPECIFICABEM','','CDEMPRESA='||:OLD.CDEMPRESA||';CDESPECIFICABEM='||:OLD.CDESPECIFICABEM||';', SYSDATE);
   END IF;
END;
/
ALTER TABLE ESPECIFICABEM MODIFY DTULTATU DEFAULT SYSDATE
/

UPDATE ESPECIFICABEM SET DTULTATU = SYSDATE WHERE DTULTATU IS NULL
/
-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_ESPECIFICABEM','5.05.119'); END;
/

