/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: QTDE_UNIDADE_ESTOQUE                                                 

Descrio:                                                                 
Retorna uma quantidade de um produto em uma determinada unidade convertida 
na unidade de estoque de acordo com a tabela CONVPRODUTO.                  
                                                                            
P_QTORIGINAL - Quantidade Original.                                        
P_SGUNIDADE  - Sigla da Unidade de Medida Original.                        
P_CDPRODUTO  - Cdigo do Produto.
P_SGUNIDPROD - Unidade do produto (evita abertura de cursor desnecessario)

Criao:
05/01/99 - Ederson

Manutenes:
04/03/99 - ZED - INCLUSAO DO PARAMETRO OPCIONAL SGUNIDPROD

*/

CREATE OR REPLACE
FUNCTION QTDE_UNIDADE_ESTOQUE
   (P_QTORIGINAL      IN NUMBER,
    P_SGUNIDADE       IN UNIDMEDIDA.SGUNIDADE%TYPE,
    P_CDPRODUTO       IN PRODUTO.CDPRODUTO%TYPE,
    P_SGUNIDPROD      IN PRODUTO.SGUNIDADE%TYPE DEFAULT NULL) RETURN NUMBER IS

   V_QTCONVERT     NUMBER;
   V_VRFATOCONVES  CONVPRODUTO.VRFATOCONVES%TYPE;
   V_SGUNIDADE     PRODUTO.SGUNIDADE%TYPE;

BEGIN

   /* Faz a converso da unidade do produto na receita */

   V_QTCONVERT := P_QTORIGINAL;

   IF NOT P_SGUNIDADE IS NULL THEN

      IF NOT P_SGUNIDPROD IS NULL THEN
         V_SGUNIDADE := P_SGUNIDPROD;
      ELSE
         SELECT SGUNIDADE
         INTO V_SGUNIDADE
         FROM PRODUTO
         WHERE (CDPRODUTO = P_CDPRODUTO);
      END IF;

      IF (V_SGUNIDADE <> P_SGUNIDADE) THEN

         SELECT MAX(VRFATOCONVES)
         INTO V_VRFATOCONVES
         FROM CONVPRODUTO
         WHERE (CDPRODUTO = P_CDPRODUTO) AND
               (SGUNIDADE = P_SGUNIDADE);

         IF NOT V_VRFATOCONVES IS NULL THEN
            V_QTCONVERT := P_QTORIGINAL * V_VRFATOCONVES;
         ELSE
            SELECT MAX(VRFTCONVER)
            INTO V_VRFATOCONVES
            FROM CONVUNID
            WHERE (SGUNIDDE   = P_SGUNIDADE) AND
                  (SGUNIDPARA = V_SGUNIDADE);

            IF NOT V_VRFATOCONVES IS NULL THEN
               V_QTCONVERT := P_QTORIGINAL * V_VRFATOCONVES;
            END IF;
         END IF;
      END IF;
   END IF;
   --P_QTDE_UNID_ESTOQ := V_QTCONVERT;
   RETURN(V_QTCONVERT);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('QTDE_UNIDADE_ESTOQUE','4.05.133'); END;
/

