/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_VENDEDOR                                                 */
/* Tabela : VENDEDOR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_VENDEDOR' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_VENDEDOR
GO

CREATE TRIGGER DTULTATU_VENDEDOR
ON VENDEDOR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'VENDEDOR', null, 'CDVENDEDOR='+ CDVENDEDOR + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE VENDEDOR
      SET DTULTATUVEND = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(VENDEDOR.CDVENDEDOR,0)  = ISNULL(INSERTED.CDVENDEDOR,0));
   END;
END;
GO

UPDATE VENDEDOR SET DTULTATUVEND = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUVEND IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUVEND' and
            type = 'D')
   ALTER TABLE VENDEDOR DROP CONSTRAINT DEFAULT_DTULTATUVEND
GO

ALTER TABLE VENDEDOR ADD CONSTRAINT DEFAULT_DTULTATUVEND
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUVEND
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_VENDEDOR','4.11.194';
GO

