var Fis03000_DapiMg_Controller = function(ScreenService, General, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil){
    var self = this;
    
    self.addAgendamento = function(widget){
        widget.newRow(); 
        widget.getField('DTREFINI').isVisible = true;
    };
    
    self.cancelAgendamento = function(args){
        General.backOrCancel(args); 
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };
    
    self.editAgendamento = function(widget){
        General.edit(widget); 
        this.periodicidadeOnChange(widget);
    };
    
    self.saveAgendamento = function(widget){
        if (widget.isValid()) {
		    var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));
            
            if((d1.getTime() > d2.getTime()) && (d1.getHours() > d2.getHours())){
                if(((widget.currentRow.CDINSCESTA == '') || (widget.currentRow.CDINSCESTA == null)) && (widget.currentRow.CDEMPRESA)){
                    widget.currentRow.CDINSCESTA = "T";
                }
                
                widget.currentRow.NRORG = getLocalVar('NRORG');
                
                General.callRestEngine('fis_acessorias#/saveAgendamentoDapiMg','Row', widget.currentRow).then(
                    function(success){
                        General.changeWidgetAcessibility(widget.widgets, true);
                        ScreenService.showMessage('Agendado com sucesso.');
                        ScreenService.goBack();
                        widget.getField('DTREFINI').isVisible = true;
                        widget.reload();
                    },
                    function(error){
                        ScreenService.showMessage(error.data.error);
                    }
                );
		    } else {
		        ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
		    }
            
        } else {
			// @todo create messages class
			ScreenService.showMessage("Preencha todos os campos corretamente!");
		}
    };
    
    self.downloadArquivoAgendado = function(dapiWidget) {
        var downloadRoute;
        var fileName;
        
        if(dapiWidget.hasCheckedRows()){
            var rows = dapiWidget.getCheckedRows();
            rows.forEach(function(row){
                downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;
                
                window.open(downloadRoute + fileName);
            });
        } 
        else {
            var row = dapiWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;
            
            window.open(downloadRoute + fileName);
        }
        
    };
    
    self.deleteAgendamento = function(widget){
        widget.currentRow.NRORG = getLocalVar('NRORG');
        
        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
        	General.callRestEngine('fis_acessorias#/deleteAgendamentoDapiMg','Row', widget.currentRow).then(
                function(success){
                    ScreenService.showMessage('Deletado com sucesso.');
                    ScreenService.goBack();
                    widget.reload();
                },
                function(error){
                    ScreenService.showMessage(error.data.error);
                }
            );
        });
    };

    self.periodicidadeOnChange = function(widget){
        if(widget.currentRow.IDPERIAGEN == 0){
            widget.getField('DTREFINI').isVisible = true;
        }
        else if(widget.currentRow.IDPERIAGEN == 1){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        }
        else if(widget.currentRow.IDPERIAGEN == 2){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };
    /**
     * Função para a chamada de Exportação
     */
    self.exportarDapi = function(dapiWidget){
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if(dapiWidget.isValid()){
            // Verifica se a parametrização não foi carregada e verificada
            if(!parametrizacaoWasLoaded(dapiWidget)){
                return;
            }
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDapiMg');
            // Define propriedades na widget principal com valores dos fields
            // da tab de parametrização
            preenhcerPropriedadesWidgetPrincipal(dapiWidget, parametrosWidget);
            var row = dapiWidget.currentRow;
            var route = 'fis#/exportarDapiMg';
            var message = Messages_fiscal.EXPORTANDO_DAPI;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    /**
     * Função auxiliar que verifica se a tab de parametrização foi aberta ao exportar,
     * através da propriedade 'empresasLoaded'.
     */ 
    var parametrizacaoWasLoaded = function(dapiWidget){
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdEmpresa = dapiWidget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('parametrosGeraisDapiMg');
        // Verifica se a propriedade (CDEMPRESA) está setada para a empresa selecionada
        parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdEmpresa];
        
        // Verifica se a widget de parametrização não foi aberta antes de
        // clicar no botão de exportar
        if(!parametrizacaoWasLoaded){
            // Muda a propriedade para que a parametrização seja obrigatória
            parametrosWidget.parametersRequired = true;
            // Exibe mensagem indicando a obrigatoriedae da verificação dos parametros
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).
            then(function(){
                // Abre a widget/tab de parâmetros
                openTabParametrosGerais(parametrosWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente aberta
            return false;
        }
        // Retorna true, caso a parametrização já tenha sido aberta
        return true;
    };
    /**
     * Função auxiliar que abre a tab de parâmetros pela primeira vez.
     */ 
    var openTabParametrosGerais = function(parametrosWidget){
        // Recarrega os dados (dataSource) parametrizados
        parametrosWidget.reload().then(function(){
            // Redesenha os dados carregados na tab
            parametrosWidget.redraw();
        });
        // Define a tab de parametricação como ativa
        parametrosWidget.activate();
    };
    /**
     * Função auxiliar que cria e preenche propriedades da widget principal,
     * com os valores das fields da tab de parâmetros
     */
    var preenhcerPropriedadesWidgetPrincipal = function(dapiWidget, parametrosWidget){
        dapiWidget.currentRow.CDDESMEMCAE       = parametrosWidget.currentRow.CDDESMEMCAE;
        dapiWidget.currentRow.CDDESMEMCNAEF     = parametrosWidget.currentRow.CDDESMEMCNAEF;
        dapiWidget.currentRow.CDREGESPRECOLHI   = parametrosWidget.currentRow.CDREGESPRECOLHI;
        dapiWidget.currentRow.CDOPTFUND         = parametrosWidget.currentRow.CDOPTFUND;
        dapiWidget.currentRow.CDMOVCAFE         = parametrosWidget.currentRow.CDMOVCAFE;
        dapiWidget.currentRow.CDDAPIMOV         = parametrosWidget.currentRow.CDDAPIMOV;
        dapiWidget.currentRow.CDDAPISUB         = parametrosWidget.currentRow.CDDAPISUB;
        dapiWidget.currentRow.CDINDENCERR       = parametrosWidget.currentRow.CDINDENCERR;
        dapiWidget.currentRow.DTLIMPAG          = parametrosWidget.currentRow.DTLIMPAG;
        dapiWidget.currentRow.CDREGIMREC        = parametrosWidget.currentRow.CDREGIMREC;
        dapiWidget.currentRow.CDTERMACEIT       = parametrosWidget.currentRow.CDTERMACEIT;
    };
    /**
     * Função para salvar os parâmetros informados - ou caso eles já existam,
     * apenas os confirmam para a exportação
     */
    self.salvarParametrizacao = function(parametrosWidget){
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if(parametrosWidget.isValid()){
            var dapiWidget = templateManager.container.getWidget('dapi-mg');
            preencherCamposAbstratosParaSalvar(parametrosWidget);
            
            var filter = [
                {
                    "name": "P_CDEMPRESA",
                    "operator": "=",
                    "value": dapiWidget.currentRow.CDEMPRESA
                },
                {
                    "name": "P_CDINSCRICAO",
                    "operator": "=",
                    "value": parametrosWidget.currentRow.CDINSCRICAO
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar('NRORG')
                }
            ];
            
            General.callRestEngine('fis_acessorias#/crud/paramdeclaces_DapiMg', 'FilterData', filter).then(function (result) {
                result = result.dataset.paramdeclaces_DapiMg;
                
                if(result.length != 0)
                    parametrosWidget.currentRow.__is_new = false;
                    
                parametrosWidget.saveRow()
                .then(function(){
                    // Seta os parametros como verificados pelo usuário
                    setParametersVerified(parametrosWidget);
                    // Ativa a widget principal
                    dapiWidget.activate();
                    dapiWidget.currentWidget = dapiWidget;
                    /**
                     * Verifica se a tela de parâmetros foi exibida devido a uma tentativa
                     * de exportação. Caso positivo, a exportação é efetuada
                     */
                    if(parametrosWidget.parametersRequired){
                        self.exportarDapi(dapiWidget);
                        // Valida a propriedade para false, caso a tela de parametros seja
                        // novamente aberta. E assim não haverá exportação sempre ao sair
                        parametrosWidget.parametersRequired = false;
                    }
                });
            });
        }
    };
    
    var preencherCamposAbstratosParaSalvar = function(parametrosWidget){
        var dapiWidget = templateManager.container.getWidget('dapi-mg');
        parametrosWidget.currentRow.CDCAMPO1    = dapiWidget.currentRow.CDLIVROMAG;
        parametrosWidget.currentRow.CDCAMPO4    = parametrosWidget.currentRow.CDDESMEMCAE;
        parametrosWidget.currentRow.CDCAMPO5    = parametrosWidget.currentRow.CDDESMEMCNAEF;
        parametrosWidget.currentRow.CDCAMPO6    = parametrosWidget.currentRow.CDREGESPRECOLHI;
        parametrosWidget.currentRow.CDCAMPO7    = parametrosWidget.currentRow.CDOPTFUND;
        parametrosWidget.currentRow.CDCAMPO8    = parametrosWidget.currentRow.CDMOVCAFE;
        parametrosWidget.currentRow.CDCAMPO9    = parametrosWidget.currentRow.CDDAPIMOV;
        parametrosWidget.currentRow.CDCAMPO10   = parametrosWidget.currentRow.CDDAPISUB;
        parametrosWidget.currentRow.CDCAMPO11   = parametrosWidget.currentRow.CDINDENCERR;
        parametrosWidget.currentRow.DTCAMPO1    = parametrosWidget.currentRow.DTLIMPAG;
        parametrosWidget.currentRow.CDCAMPO13   = parametrosWidget.currentRow.CDREGIMREC;
        parametrosWidget.currentRow.CDCAMPO14   = parametrosWidget.currentRow.CDTERMACEIT;
    };
    /**
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário
     */
    var setParametersVerified = function(parametrosWidget){
        var currentRow = parametrosWidget.currentRow;
        var dapiMgIsSelected = parametrosWidget.name == "parametrosGeraisDapiMg";
        if (dapiMgIsSelected) {
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
        else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    }; 
    /**
     * Função que é invocada após o carregamento do dataSource. Caso é 
     * retornado algo, adiciona à currentRow o primeiro indice de data[] - caso
     * contrário, é setada em forma de newRow;
     */ 
    self.setLoadedParameters = function(parametrosWidget){
        var dapiWidget = templateManager.container.getWidget('dapi-mg');
        if(parametrosWidget.dataSource.data.length > 0){
            // Seta a currentRow como sendo o primeiro indice do data[] retornado
            parametrosWidget.moveToFirst();
            // Redesenha na widget principal, os fields com os valores da nova 
            // currentRow
            parametrosWidget.redraw();
        }else{
            // Seta a widget em modo de novo dado, para inserir a parametrização
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = dapiWidget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = dapiWidget.currentRow.NMEMPRESA;
    };
    /**
     * Função invocada ao sair da widget de parametros, que seta os mesmos como 
     * verificados
     */ 
    self.beforeExitParametrosGerais = function(parametrosWidget){
        // Seta a parametrização como verificada somente se a widget não estiver
        // em modo de inserção, mas sim de verificação
        if(!parametrosWidget.isNewRow()){
            setParametersVerified(parametrosWidget);
        }
    };
    /**
     * Função que é invocada ao alterar o field CDINSCESTA,
     * alterando a propriedade enable da tab de parâmetros
     */ 
    self.inscricaoOnChange = function(dapiWidget){
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDapiMg');
        // Variável booleana que é setada como true, caso alguma inscrição seja 
        // selecionada
        var inscricaoIsSelect = !!dapiWidget.currentRow.CDINSCESTA;
        parametrosWidget.enabled = inscricaoIsSelect;
    };
};
Configuration(function(ContextRegister){
    ContextRegister.register("Fis03000_DapiMg_Controller", Fis03000_DapiMg_Controller);
});